/****************************************************************************/
/*                                                                          */
/*              ABEDEMO5.C, lens and some similar effects.                  */
/*                                                                          */
/*         Choose between the transformations with keys 1 to 5              */
/*       Borland C users: build with "bcc -1 abedemo5.c lens.asm"           */
/*  or make a project and add abedemo5.c and lens.asm, memory model small.  */
/*                                                                          */
/*                      /Abe Racadabra October 1996                         */
/*                                                                          */
/****************************************************************************/
#include "mklens.c"
#include "viewtga.c"

/* these are defined in lens.asm */
extern void lenshow(int x,int y);
extern void restore(int x,int y);
extern char far* screenadr(void);
extern void wtsync(void);
extern void setmode(int mode);

void main(void)
{
int x,y,dx,dy;
unsigned char pal[3*256],ch;

x=0;
y=0;
dx=1;
dy=1;

choosetype(); /* defined in mklens.c, calculates the tfm array */
setmode(0x013);
ViewTgaNGetPal("boris.tga", pal); /* defined in viewtga.c */

lenshow(x,y);	/* show the effect the first time */
do
{
	if(kbhit())	/* if key pressed, change the tfm array */
	{
		ch=getch();
		switch(ch)
		{
			case '1': makelens(tfm); break;
			case '2': makeinvert(tfm); break;
			case '3': makeflipx(tfm); break;
			case '4': makeflipy(tfm); break;
			case '5': makemagnify(tfm); break;
		}
	}
	wtsync();
	restore(x,y);   /* restore the saved background */
	/* calculate new coordinates */
	if(x+dx+D>319 || x+dx<0) dx=-dx; /* D is defined in mklens.c */
	if(y+dy+D>199 || y+dy<0) dy=-dy;
	x+=dx;
	y+=dy;
	lenshow(x,y); /* apply the tfm effect */
}while(ch!='\x1b');   /* repeat until Esc key is pressed */
setmode(3);
}
