#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <stdio.h>

#define D 64        /* Diameter. If you change D here, remember to also */
		    /* change D in lens.asm */
int tfm[D*D];

void makelens(int*tfm)
{
int M=10;        /* Magnificationfactor */
int r,m,y,x,a,b;
float s,z;

r =D/2;
s = sqrt(r*r - M*M);

for(y = -r;y<r;y++)
{
		for(x=-r;x<r;x++)
		{
		 if(x*x + y*y >= s*s)
		 {
			a = x;
			b = y;
		 }
		 else
		 {
			z = sqrt(r*r - x*x - y*y);
			a = (x * M /(float)z + 0.5);
			b = (y * M /(float)z + 0.5);
		 }
		 tfm[(y + r)*D + (x + r)] = (b + r)*D + (a + r);
		}
}
}


void makeinvert(int*tfm)
{
int i;
	for(i=0;i<D*D;i++) tfm[D*D-1-i]=i;
}

void makeflipx(int*tfm)
{
int i,j;
	for(i=0;i<D;i++)
	{
	for(j=0;j<D;j++)
	tfm[i*D+j] = i*D + D-1 - j;
	}
}

void makeflipy(int*tfm)
{
int i,j;
	for(i=0;i<D;i++)
	{
	for(j=0;j<D;j++)
	tfm[j*D+i] = (D-1-j)*D + i;
	}
}

void makemagnify(int*tfm)
{
int i,j;
int MAG=2;      //magnificationfactor
	for(i=0;i<D;i++)
	{
	for(j=0;j<D;j++)
	tfm[i*D+j] = (i/MAG)*D + (j/MAG);
	}
}

void choosetype(void)
{
char type;
clrscr();
printf("Press keys 1 to 5 to change transformation during runtime\n");
printf("Choose starting transformtype:\n\n");
printf("1:\tLens\n");
printf("2:\tInvert\n");
printf("3:\tFlip X-direction\n");
printf("4:\tFlip Y-direction\n");
printf("5:\tMagnify upper left corner\n");
printf("type: ");
type='0';
while(type!='1' && type!='2' && type!='3' && type!='4' && type!='5')
type = getch();
printf("%c\n",type);
switch(type)
{
	case '1': makelens(tfm); break;
	case '2': makeinvert(tfm); break;
	case '3': makeflipx(tfm); break;
	case '4': makeflipy(tfm); break;
	case '5': makemagnify(tfm); break;
}
}
